struct s_prop_AO
(
	Base = rollout_AppDisplay.s_prop_Abstruct(),
	
	fn getFilters =
	(
		Base.getFilters()
	),
	
	fn getRowsByFilter filt =
	(
		Base.getRowsByFilter filt
	),
	
	fn generateGrads =
	(
		for i = 1 to Base.Rows.count do (
			if Base.Rows[i].keyColor == undefined then (
				local j = i - 1
				while(Base.Rows[j].keyColor == undefined and j > 1) do
					j -= 1
				
				local k = i + 1
				while(Base.Rows[k].keyColor == undefined and k < Base.Rows.count) do
					k += 1
				
				Base.Rows[i].keyColor = Base.Rows[j].keyColor * (k - i) / (k - j) + Base.Rows[k].keyColor * (i - j) / (k - j)
			)
		)
	),
	
	fn createMaterials =
	(
		
	),
	
	fn init objs:objects forced:false =
	(
		if forced then (
			Base.Rows = #()
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"{0%}"				keyColor:black	)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(0% , 10%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(10% , 20%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(20% , 30%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(30% , 40%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(40% , 50%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(50% , 60%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(60% , 70%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(70% , 80%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(80% , 90%]"							)
			append Base.Rows (rollout_AppDisplay.s_rowData rowLabel:"(90% , 100%]"	keyColor:white)
			generateGrads()
			
			local objs = for o in objects where not o.isHidden collect o
			local counts = for o in objs collect 0
			local m = (animationRange.end - animationRange.start) as float / ticksPerFrame
			local currentSliderTime = sliderTime
			
			max create mode
			for f = animationRange.start to animationRange.end do (
				sliderTime = f
				local visibleObjs = boxPickNode (box2 [0,0] (getViewSize()))
				for o in visibleObjs do
					counts[findItem objs o] += 1
			)
			
			sliderTime = currentSliderTime
			
			for i = 1 to objs.count do (
				local n = (10 * counts[i] / m) + 1
				if n > 1 and n < Base.Rows.count then
					n = n as integer + 1
				append Base.Rows[n].objs objs[i]
			)
			
			Base.initialized = true
		)
	),
	
	fn getRows =
	(
		Base.getRows()
	),
	
	fn setValue row objs =
	(
		
	),
	
	fn addRow =
	(
		Base.addRow()
	),
	
	fn setLabel row newLabel =
	(
		
	)
)

s_prop_AO()